Public Class frmMain

    Private btnCalc As Button

    Private mdblResult As Double
    Private mdblSavedNumber As Double
    Private mstrDot As String
    Private mstrOp As String
    Private mstrDisplay As String
    Private mblnDecEntered As Boolean
    Private mblnOpPending As Boolean
    Private mblnNewEquals As Boolean
    Private mblnEqualsPressed As Boolean

    Private Sub frmMain_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown

        Dim intIndex As Integer

        Select Case e.KeyCode
            Case Keys.Back : intIndex = 0
            Case Keys.Delete : intIndex = 1
            Case Keys.Escape : intIndex = 2
            Case Keys.D0, Keys.NumPad0 : intIndex = 18
            Case Keys.D1, Keys.NumPad1 : intIndex = 13
            Case Keys.D2, Keys.NumPad2 : intIndex = 14
            Case Keys.D3, Keys.NumPad3 : intIndex = 15
            Case Keys.D4, Keys.NumPad4 : intIndex = 8
            Case Keys.D5, Keys.NumPad5 : intIndex = 9
            Case Keys.D6, Keys.NumPad6 : intIndex = 10
            Case Keys.D7, Keys.NumPad7 : intIndex = 3
            Case Keys.D8, Keys.NumPad8 : intIndex = 4
            Case Keys.D9, Keys.NumPad9 : intIndex = 5
            Case Keys.Decimal : intIndex = 20
            Case Keys.Add : intIndex = 21
            Case Keys.Subtract : intIndex = 16
            Case Keys.Multiply : intIndex = 11
            Case Keys.Divide : intIndex = 6
            Case Else : Exit Sub
        End Select

        btnCalc = DirectCast(GetControlByName(Me, "btnCalc" & intIndex), Button)
        btnCalc.Focus()

    End Sub

    Private Sub frmMain_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Me.KeyPress

        Dim intIndex As Integer

        Select Case e.KeyChar
            Case "S", "s" : intIndex = 7
            Case "P", "p" : intIndex = 12
            Case "R", "r" : intIndex = 17
            Case "X", "x" : intIndex = 11
            Case "=" : intIndex = 22
            Case Else : Exit Sub
        End Select

        btnCalc = DirectCast(GetControlByName(Me, "btnCalc" & intIndex), Button)
        btnCalc.Focus()

    End Sub

    Private Sub btnCalc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
    Handles btnCalc0.Click, btnCalc1.Click, btnCalc2.Click, btnCalc3.Click, btnCalc4.Click, _
            btnCalc5.Click, btnCalc6.Click, btnCalc7.Click, btnCalc9.Click, btnCalc10.Click, _
            btnCalc11.Click, btnCalc12.Click, btnCalc13.Click, btnCalc14.Click, btnCalc15.Click, _
            btnCalc16.Click, btnCalc17.Click, btnCalc18.Click, btnCalc19.Click, btnCalc20.Click, _
            btnCalc20.Click, btnCalc21.Click, btnCalc22.Click

        Dim strPressedKey As String

        If mstrDisplay = "ERROR" Then
            mstrDisplay = ""
        End If

        btnCalc = DirectCast(sender, Button)
        strPressedKey = btnCalc.Text

        Select Case strPressedKey
            Case "0", "1", "2", "3", "4", _
                 "5", "6", "7", "8", "9"
                If mblnOpPending Then
                    mstrDisplay = ""
                    mblnOpPending = False
                End If
                If mblnEqualsPressed Then
                    mstrDisplay = ""
                    mblnEqualsPressed = False
                End If
                mstrDisplay = mstrDisplay & strPressedKey
            Case "."
                If mblnOpPending Then
                    mstrDisplay = ""
                    mblnOpPending = False
                End If
                If mblnEqualsPressed Then
                    mstrDisplay = ""
                    mblnEqualsPressed = False
                End If
                If InStr(mstrDisplay, ".") > 0 Then
                    Beep()
                Else
                    mstrDisplay = mstrDisplay & strPressedKey
                End If
            Case "+", "-", "X", "/"
                mdblResult = Val(mstrDisplay)
                mstrOp = strPressedKey
                mblnOpPending = True
                mblnDecEntered = False
                mblnNewEquals = True
            Case "%"
                mdblSavedNumber = (Val(mstrDisplay) / 100) * mdblResult
                mstrDisplay = CStr(mdblSavedNumber)
            Case "="
                If mblnNewEquals Then
                    mdblSavedNumber = Val(mstrDisplay)
                    mblnNewEquals = False
                End If
                Select Case mstrOp
                    Case "+"
                        mdblResult = mdblResult + mdblSavedNumber
                    Case "-"
                        mdblResult = mdblResult - mdblSavedNumber
                    Case "X"
                        mdblResult = mdblResult * mdblSavedNumber
                    Case "/"
                        If mdblSavedNumber = 0 Then
                            mstrDisplay = "ERROR"
                        Else
                            mdblResult = mdblResult / mdblSavedNumber
                        End If
                    Case Else
                        mdblResult = Val(mstrDisplay)
                End Select
                If mstrDisplay <> "ERROR" Then
                    mstrDisplay = CStr(mdblResult)
                End If
                mblnEqualsPressed = True
            Case "+/-"
                If mstrDisplay <> "" Then
                    If Strings.Left(mstrDisplay, 1) = "-" Then
                        mstrDisplay = Strings.Right(mstrDisplay, 2)
                    Else
                        mstrDisplay = "-" & mstrDisplay
                    End If
                End If
            Case "Backspace"
                If Val(mstrDisplay) <> 0 Then
                    mstrDisplay = Strings.Left(mstrDisplay, Len(mstrDisplay) - 1)
                    mdblResult = Val(mstrDisplay)
                End If
            Case "CE"
                mstrDisplay = ""
            Case "C"
                mstrDisplay = ""
                mdblResult = 0
                mdblSavedNumber = 0
            Case "1/x"
                If Val(mstrDisplay) = 0 Then
                    mstrDisplay = "ERROR"
                Else
                    mdblResult = Val(mstrDisplay)
                    mdblResult = 1 / mdblResult
                    mstrDisplay = CStr(mdblResult)
                End If
            Case "sqrt"
                If Val(mstrDisplay) < 0 Then
                    mstrDisplay = "ERROR"
                Else
                    mdblResult = Val(mstrDisplay)
                    mdblResult = Math.Sqrt(mdblResult)
                    mstrDisplay = CStr(mdblResult)
                End If
        End Select

        If mstrDisplay = "" Then
            lblDisplay.Text = "0."
        Else
            mstrDot = IIf(InStr(mstrDisplay, ".") > 0, "", ".")
            lblDisplay.Text = mstrDisplay & mstrDot
            If Strings.Left(lblDisplay.Text, 1) = "0" Then
                lblDisplay.Text = Mid$(lblDisplay.Text, 2)
            End If
        End If

        If lblDisplay.Text = "." Then lblDisplay.Text = "0."

    End Sub

    Private Function GetControlByName(ByVal pobjParent As Control, _
                                      ByVal pstrCtlName As String) _
    As Control

        Dim objCtl As Control

        For Each objCtl In pobjParent.Controls
            If objCtl.Name = pstrCtlName Then
                Return (objCtl)
            End If
        Next

        ' if control is not found
        Return Nothing

    End Function

End Class